////////////////////////////////////////////////////////////////////////////////////////////
//
// PRODUCT: Norton Internet Security/Symantec Desktop Firewall
//
// NAME:    AutoCorrect.js (Javascript file for AUTOCORRECT.HTM)
//
// Copyright (c) 2001 by Symantec Corporation. All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////////////////

var RestrictedZoneName = "NISRestricted";
var AddressElementName = "Address";

function Unblock_OnClick()
{
	var nSel = badList.GetCurSel();
	if (nSel >= 0)
	{
		var ip = badList.GetCellText(nSel, 0);
		BlockList.ClearAddress(ip);
	}
}

function UnblockAll_OnClick()
{
	BlockList.ClearAll();
}

function Exclusions_OnClick()
{
    webWnd.showModalDialog("res://nisplug.dll/Exclusions-Popup.htm", 530, 372, null);
}

function Restrict_OnClick()
	{
	var nSel = badList.GetCurSel();
	if (nSel >= 0)
		{
		if(!gRegOrXml.IsIPInList(RestrictedZoneName,badList.GetCellText(nSel,0)))
			{
			var FirewallXML = GetFirewallXML(gZones);
			if(FirewallXML)
				{
				var zonenode = GetPtrToZoneNode(FirewallXML,RestrictedZoneName);
				if(zonenode)
					{
					var NewElem = FirewallXML.createElement(AddressElementName);
					NewElem.text = badList.GetCellText(nSel,0);
					zonenode.appendChild(NewElem);
					gZones.FirewallData = FirewallXML;	// Save the new list...
					alert(StrID("AddressRestricted")+badList.GetCellText(nSel,0));
					}
				}
			}
		else
			alert(StrID("IPDupeEntry"));
		}
	}

function badList_OnClick()
{
	// The Unblock and Restrict buttons depends upon the selection state of this list
	// so update them when the selection changes
	UpdateUnblockDisabledState();
	UpdateRestrictDisabledState();
}

function badList_OnDblClick()
{
	// RTROLLO - Do nothing -- I don't want to unblock, because that might not be
	// what the user would expect.  TomP thinks maybe this should go to the log
}

function OnLoad()
{
	// Setup the list control
	badList.SetTableClass("ListBoxClass");
	badList.OnClick = badList_OnClick;
	badList.OnDblClick = badList_OnDblClick;

	// set checkboxes
	SDEnable.checked = StatusInfo.ScanDetectEnabled;
	ABEnable.checked = StatusInfo.AutoBlockEnabled;

	// Set the updatable settings
	UserManager_OnUserChange();
	OnTimerClick();

	setInterval("OnTimerClick()", 1000);
}

function UserManager_OnUserChange()
{
    CurUser.style.display = "none";
	var ProdType = UserManager.ProductType;
	if ((ProdType == "PT_FE") || (ProdType == "PT_NOAD"))
	{
        // DWong 01/16/01 Defect 347937 - display log in account
        // for family edition and no-ad products only

	    // If the PCWiz hasn't been run hide the user name
	    if(UserManager.PCWizRun)
        {
		    CurUser.style.display = "";

	        // Change the text for "User Logged in As" for Not Logged in User
	        // Since the user name of "Not Logged in" is an empty string.  We compare it against string lenght 0
	        var szCurrentUser = UserManager.CurrentUser;
	        if(szCurrentUser.length == 0)
            {
		        UserNameText.innerText = StrID("UserNotLoggedIn");
	            currentUser.innerHTML = "";
            }
            else
            {
		        UserNameText.innerText = StrID("UserLoggedIn");

	            // Set the current user name
	            currentUser.innerHTML = szCurrentUser;
            }
        }
	}

	UserType = UserManager.CurrentUserType;
	// The Unblock, Restrict and Unblock All buttons depend upon the type of the user
	// so update them when the user changes
	UpdateUnblockDisabledState();
	UpdateRestrictDisabledState();
	UpdateUnblockAllDisabledState();
	if(UserType != "UT_SUPERVISOR")
	{
		Exclusions.disabled = true;		
		SDEnable.disabled = true;
		ABEnable.disabled = true;
	}
	else
	{
		Exclusions.disabled = false;		
		SDEnable.disabled = false;
		ABEnable.disabled = false;
	}
}

function UpdateUnblockDisabledState()
{
	Unblock.disabled = (UserType != "UT_SUPERVISOR" || badList.GetCurSel() < 0);
}

function UpdateRestrictDisabledState()
{
	Restrict.disabled = (UserType != "UT_SUPERVISOR" || badList.GetCurSel() < 0);
}

function UpdateUnblockAllDisabledState()
{
	UnblockAll.disabled = (UserType != "UT_SUPERVISOR" || badList.GetRowCount() == 0);
}

function InitListFromFirewall()
{
	var selSave = badList.GetCurSel();

	// Reset the list control
	badList.DeleteAllRows();
	badList.SetColumnCount(1);
	badList.SetColumnWidth(1, "100%");

	var xmlDoc = BlockList.AddressList;
	if (xmlDoc != null)
	{
		var blockList = xmlDoc.selectNodes("/*/Address");
		for (iItem = 0; iItem < blockList.length; iItem++)
		{
			pRow = badList.InsertRow(-1);
			badList.SetCellTextPtr(pRow, 0, blockList[iItem].nodeTypedValue);
		}		

		// restore selected row if any
		if (selSave >= badList.GetRowCount())
			selSave = -1;
		badList.SetCurSel(selSave);
	}

	// The Unblock, Restrict and Unblock All buttons depend upon the contents of the list
	// so update them when the contents of the list change
	UpdateUnblockDisabledState();
	UpdateRestrictDisabledState();
	UpdateUnblockAllDisabledState();
}

function stricmp(szA, szB)
{
	if(szA.toUpperCase() < szB.toUpperCase())
		return -1;
	else if(szA.toUpperCase() > szB.toUpperCase())
		return 1;

	return 0;
}

function SDEnable_OnClick()
{
	StatusInfo.ScanDetectEnabled = SDEnable.checked;
}

function ABEnable_OnClick()
{
	StatusInfo.AutoBlockEnabled = ABEnable.checked;
}

function OnTimerClick()
{
	InitListFromFirewall();
}

function GetFirewallXML(Zones)
	{
	var FirewallXML = new ActiveXObject("Microsoft.XMLDOM");
	FirewallXML.loadXML(Zones.FirewallData.xml);
	return FirewallXML;
	}

function GetPtrToZoneNode(FirewallXML,szZoneName)
	{
	var szXSLSearch = "/FirewallData/Zones/Zone[ZoneName = \"" + szZoneName + "\"]";
	var zonenode = FirewallXML.selectSingleNode(szXSLSearch);	// Do a XSL Pattern search for the requested zone
	if (!zonenode)
		{
		// there is no zone node of this type.  Create one now.
		var pnode = FirewallXML.createElement("ZoneName");
		pnode.text = szZoneName;
		var zonearea = FirewallXML.createElement("Zone");
		zonearea.appendChild(pnode);
		var zones = FirewallXML.selectSingleNode("/FirewallData/Zones");
		zones.appendChild(zonearea);
		zonenode = FirewallXML.selectSingleNode(szXSLSearch);		// now try it again.
		}
	return zonenode;
	}
