////////////////////////////////////////////////////////////////////////////////////////////
//
// PRODUCT: Norton Internet Security/Symantec Desktop Firewall
//
// NAME:    Exclusions-Popup.js (Javascript file for EXCLUSIONS-POPUP.HTM)
//
// Copyright (c) 2001 by Symantec Corporation. All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////////////////

var g_szCurTab = "NISScanning";
var g_FirewallXML = null;

function AddBHandler()
{
	// Call fwui.dll (IP-Popup.html), if the user types in data add it to our list
    var xmlIPList = webWnd.showModalDialog("res://fwui.dll/IP-Popup.htm", 450, 330, null);
	if(xmlIPList)
		InsertDataIntoZone(g_szCurTab, xmlIPList);
}

function DeleteBHandler()
{
	var nCurSel = addrList.GetCurSel();
	DeleteDataFromZone(g_szCurTab, nCurSel);
}

function addrList_OnClick()
{
	DeleteB.disabled = false;
}

function addrList_OnDblClick()
{
	//ModifyB.click();
}

function badList_OnClick()
{
	ExcludeB.disabled = false;
}

function ExcludeBHandler()
{
	var xmlIPList = new ActiveXObject("Microsoft.XMLDOM");
	xmlIPList.loadXML("<list/>");
	var sAddress = new String(badList.GetCellText(badList.GetCurSel(), 0));
	node = xmlIPList.createElement("Address");
	node.text = sAddress;
	xmlIPList.documentElement.appendChild(node);

	InsertDataIntoZone(g_szCurTab, xmlIPList);
}

function OnTimerClick()
{
	InitListFromFirewall();
}
	
function OnLoad()
{
	// Set the title...
	window.title = UserManager.ProductName;

	// Setup the list control
	badList.SetTableClass("ListBoxClass");
	badList.OnClick = badList_OnClick;
//	badList.OnDblClick = badList_OnDblClick;

	// Init from the block list since it is the first visible list
	InitListFromFirewall();
	

	// Load the XML data from the engine...
	g_FirewallXML = new ActiveXObject("Microsoft.XMLDOM");
	g_FirewallXML.loadXML(Zones.FirewallData.xml);

	// Setup the list control
	addrList.SetTableClass("ListBoxClass");
	addrList.OnClick = addrList_OnClick;
	addrList.OnDblClick = addrList_OnDblClick;

	InitListFromXML(g_szCurTab);
	
	OKB.focus();

	setInterval("OnTimerClick()", 1000);
}

function InitListFromFirewall()
{
	var selSave = badList.GetCurSel();

	// Reset the list control
	badList.DeleteAllRows();
	badList.SetColumnCount(1);
	badList.SetColumnWidth(1, "100%");

	var xmlDoc = BlockListObj.AddressList;
	if (xmlDoc != null)
	{
		var blockList = xmlDoc.selectNodes("/*/Address");
		for (iItem = 0; iItem < blockList.length; iItem++)
		{
			pRow = badList.InsertRow(-1);
			badList.SetCellTextPtr(pRow, 0, blockList[iItem].nodeTypedValue);
		}
	}

	// restore selected row if any
	if (selSave >= badList.GetRowCount())
		selSave = -1;
	badList.SetCurSel(selSave);

	ExcludeB.disabled = (badList.GetCurSel() == -1);
}

function InitListFromXML(sztab)
{
	// Reset the list control
	addrList.DeleteAllRows();
	addrList.SetColumnCount(1);

	// Disable the modify/delete buttons
	DeleteB.disabled = true;

	// Get the node for this zone and walk the children
	var ZoneNode = GetPtrToZoneNode(sztab);
	if(ZoneNode)
	{
		var pZoneChildNodeList = ZoneNode.childNodes;
		var ChildCount = 0;

		for(ChildCount = 0; ChildCount < pZoneChildNodeList.length; ChildCount++)
		{
			var ZoneChildNode = pZoneChildNodeList.item(ChildCount);

			if(stricmp(ZoneChildNode.nodeName, "MaskedAddress") == 0)
			{
				var chunks = ZoneChildNode.nodeTypedValue.split(":");
				var text = StrID("IP") + ": " + chunks[0] + "<BR>" + StrID("Mask") + ": " + chunks[1];

				pRow = addrList.InsertRow(-1);
				addrList.SetCellTextPtr(pRow, 0, text);
			}
			else if(stricmp(ZoneChildNode.nodeName, "AddressRange") == 0)
			{
				var chunks = ZoneChildNode.nodeTypedValue.split(":");
				var text = StrID("From") + ": " + chunks[0] + "<BR>" + StrID("To") + ": " + chunks[1];

				pRow = addrList.InsertRow(-1);
				addrList.SetCellTextPtr(pRow, 0, text);
			}
			else if(stricmp(ZoneChildNode.nodeName, "NamedAddress") == 0)
			{
				var text = StrID("Name") + ": " + ZoneChildNode.nodeTypedValue;

				pRow = addrList.InsertRow(-1);
				addrList.SetCellTextPtr(pRow, 0, text);
			}
			else if(stricmp(ZoneChildNode.nodeName, "Address") == 0)
			{
				var text = StrID("IP") + ": " + ZoneChildNode.nodeTypedValue;

				pRow = addrList.InsertRow(-1);
				addrList.SetCellTextPtr(pRow, 0, text);
			}
		}
	}
}

function GetPtrToZoneNode(szZoneName)
{
	// Do a XSL Pattern search for the requested zone
	var szXSLSearch = "/FirewallData/Zones/Zone[ZoneName = \"" + szZoneName + "\"]";

	var zonenode = g_FirewallXML.selectSingleNode(szXSLSearch);

	if (!zonenode)
	{
		// there is no zone node of this type.  Create one now.

		var pnode = g_FirewallXML.createElement("ZoneName");
		pnode.text = szZoneName;

		var zonearea = g_FirewallXML.createElement("Zone");
		zonearea.appendChild(pnode);

		var zones = g_FirewallXML.selectSingleNode("/FirewallData/Zones");
		zones.appendChild(zonearea);

		// now try it again.
		zonenode = g_FirewallXML.selectSingleNode(szXSLSearch);
	}
	return zonenode;
}

function InsertDataIntoZone(szZoneName, xmlIPList)
{
	var ZoneNode = GetPtrToZoneNode(szZoneName);
	var IPCount;

	if (ZoneNode)
	{
        var addressNodeList = xmlIPList.selectNodes(".//(Address|NamedAddress|AddressRange|MaskedAddress)");
		for (IPCount = 0; IPCount < addressNodeList.length; IPCount++)
		{
			var IPEntry = addressNodeList.item(IPCount);
			var pNewElem = CreateElementForZone(szZoneName, IPEntry);

			if (pNewElem)
			{
				var Existing = ZoneNode.selectSingleNode(".[$any$ " + pNewElem.nodeName + "='" + pNewElem.text + "']");
				// Add the data to the zone
				if (!Existing) 
					ZoneNode.appendChild(pNewElem);
			}
		}

		// Reload the displayed list
		InitListFromXML(szZoneName);
	}
}

function CreateElementForZone(szZoneName, xmlIPEntry)
{
	var ZoneNode = GetPtrToZoneNode(szZoneName);

	if(!ZoneNode || !xmlIPEntry)
		return null;

	var szElementName = null;
	var szElementValue = null;

	if(stricmp(xmlIPEntry.nodeName, "Address") == 0)
	{
		szElementName = "Address";
		szElementValue = xmlIPEntry.nodeTypedValue;
	}
	else if(stricmp(xmlIPEntry.nodeName, "NamedAddress") == 0)
	{
		szElementName = "NamedAddress";
		szElementValue = xmlIPEntry.nodeTypedValue;
	}
	else if(stricmp(xmlIPEntry.nodeName, "AddressRange") == 0)
	{
		szElementName = "AddressRange";
//		var szText = "" + xmlIPEntry.nodeTypedValue;
//		var chunks = szText.split(":");
//		szElementValue = chunks[0] + "-" + chunks[1];
		szElementValue = xmlIPEntry.nodeTypedValue;
	}
	else if(stricmp(xmlIPEntry.nodeName, "MaskedAddress") == 0)
	{
		szElementName = "MaskedAddress";
		szElementValue = xmlIPEntry.nodeTypedValue;
	}

	//
	// Add the data to the zone
	//
	if(szElementName && szElementValue)
	{
		var pNewElem = g_FirewallXML.createElement(szElementName);
		pNewElem.text = szElementValue;
		return pNewElem;
	}

	return null;
}

function ModifyDataInZone(szZoneName, nItem, xmlIPList)
{
	var ZoneNode = GetPtrToZoneNode(szZoneName);
	var IPCount;

	if (ZoneNode)
	{
		// Get the old node
		nItem = nItem + 1;	// To move past <ZoneName>

        var addressNodeList = xmlIPList.selectNodes(".//(Address|NamedAddress|AddressRange|MaskedAddress)");
		for (IPCount = 0; IPCount < addressNodeList.length; IPCount++)
		{
			var IPEntry = addressNodeList.item(IPCount);
			var pNewElem = CreateElementForZone(szZoneName, IPEntry);
			var pOldElem = ZoneNode.childNodes.item(nItem);

			// Replace the node
			ZoneNode.replaceChild(pNewElem, pOldElem);
			nItem = nItem + 1;
		}

		// Reload the displayed list
		InitListFromXML(szZoneName);
	}
}

function DeleteDataFromZone(szZoneName, nItem)
{
	var ZoneNode = GetPtrToZoneNode(szZoneName);

	// Remove the data from the zone
	if(ZoneNode)
	{
		nItem = nItem + 1;	// To move past <ZoneName>
		var ZoneChildNode = ZoneNode.childNodes.item(nItem);
		ZoneNode.removeChild(ZoneChildNode);

		// Reload the displayed list
		InitListFromXML(szZoneName);
	}
}

function stricmp(szA, szB)
{
	if(szA.toUpperCase() < szB.toUpperCase())
		return -1;
	else if(szA.toUpperCase() > szB.toUpperCase())
		return 1;

	return 0;
}

function OKB_OnClick()
{
	// Save the list...
	Zones.FirewallData = g_FirewallXML;
    window.navigate("res://closeme.xyz");
}

function CancelB_OnClick()
{
    window.navigate("res://closeme.xyz");
}