////////////////////////////////////////////////////////////////////////////////////////////
//
// PRODUCT: Norton Internet Security/Symantec Desktop Firewall
//
// NAME:    HomeNet.js (Javascript file for HOMENET.HTM)
//
// Copyright (c) 2001 by Symantec Corporation. All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////////////////

var g_szCurTab = null;
var g_FirewallXML = null;

// assumes either a maskedAddress or a Address
function getIPFromNode(node)
{
	var IP;

	if (stricmp("MaskedAddress", node.nodeName) == 0)
	{
		var nodenamesplit = node.text.split(":");
		IP = nodenamesplit[0];
	}
	else
		IP = node.text;
	return IP;
}

function AddBHandler()
{
	var Params = "permit NISTrusted";

	// Call fwui.dll (IP-Popup.html), if the user types in data add it to our list

	if (g_szCurTab == "NISRestricted")
	{
		Params = "block NISRestricted";
	}

    var xmlIPList = webWnd.showModalDialog("res://fwui.dll/IP-Popup.htm", 450, 330, Params);
	if(xmlIPList)
	{
		// check to verify that it isn't duplicated in other list
		var IPCount;
        var addressNodeList = xmlIPList.selectNodes(".//(Address|NamedAddress|AddressRange|MaskedAddress)");
		var szOtherZone;
		var PostText;
		var IPDupEntry
		var OtherZoneChild;
		var bFoundADupe = false;
		var duplicated;
		var duplicatedIP;


		if (g_szCurTab == "NISRestricted")
		{
			PostText = StrID("IPInTrusted_POST");
			szOtherZone = "NISTrusted";
		}
		else
		{
			PostText = StrID("IPInRestricted_POST");
			szOtherZone = "NISRestricted";
		}




		for (IPCount = 0; IPCount < addressNodeList.length; IPCount++)
		{
			IPDupEntry = addressNodeList.item(IPCount);
			duplicated = false;

			if (IPDupEntry)
			{

				duplicatedIP = getIPFromNode(IPDupEntry)
				duplicated = regORxml.IsIPInList(szOtherZone, duplicatedIP);
			}




			// yes, it exists in the other zone, but which one? Start the search.
			if (duplicated)
			{

				var OtherZoneNode = g_FirewallXML.selectSingleNode("/FirewallData/Zones/Zone[ZoneName = \"" + szOtherZone + "\"]");
				var pZoneChildNodeList = OtherZoneNode.childNodes;

				for (OtherZoneChild = 0 ; OtherZoneChild < pZoneChildNodeList.length; OtherZoneChild++)
				{
					var ZoneChildNode = pZoneChildNodeList.item(OtherZoneChild);
					var ZoneChildIP = getIPFromNode(ZoneChildNode);


					// exact match of node types
					 if(stricmp(ZoneChildNode.nodeName, IPDupEntry.nodeName) == 0 &&
					    stricmp(ZoneChildIP,duplicatedIP) == 0)
					{
						// this second test is just a sanity to make sure we actually FOUND the child before deleting it.
						bFoundADupe = true;
						break;
					}
					// MaskedAddress compared to an address or visaversa
					else if (
					        (
						(stricmp(ZoneChildNode.nodeName, "Address") == 0 && stricmp(IPDupEntry.nodeName,"MaskedAddress") == 0) || 
						(stricmp(ZoneChildNode.nodeName, "MaskedAddress") == 0 && stricmp(IPDupEntry.nodeName,"Address") == 0 )
						     ) &&
					    stricmp(ZoneChildIP,duplicatedIP) == 0)					
					{
						bFoundADupe = true;
						break;
					}

					// address compared to an address range.
					else if (stricmp(ZoneChildNode.nodeName, "AddressRange") == 0 && stricmp(IPDupEntry.nodeName,"Address") == 0)
					{
						var  rangehalves = ZoneChildNode.text.split(":");

						var lowhalf = inet_addr(rangehalves[0]);
						var highhalf = inet_addr(rangehalves[1]);
						var t = inet_addr(duplicatedIP);

						if ((lowhalf < t)  && (t < highhalf))
						{
							bFoundADupe = true;
							break;
						}
					}

				}

				if (bFoundADupe)
					break;
			}
		}

		if (!bFoundADupe)
		{
			InsertDataIntoZone(g_szCurTab, xmlIPList);
		}
		else 
		{
			var IDYES =      6; 
			var MB_YESNO =  0x00000004;
			var MB_ICONQUESTION =  0x00000020;
			var txt;

		    txt = StrID("IPPRE") + " " + duplicatedIP + " " + PostText + "\n" + StrID("IPRemoveFromList");

			if (webWnd.MsgBox(txt, StrID("IPRemoveTitle"), MB_YESNO | MB_ICONQUESTION) == IDYES)
			{
				DeleteDataFromZone(szOtherZone, OtherZoneChild - 1)
				InsertDataIntoZone(g_szCurTab, xmlIPList);
			}
		}
	}
}

function DeleteBHandler()
{
	var nCurSel = addrList.GetCurSel();
	DeleteDataFromZone(g_szCurTab, nCurSel);
}

function HomeNetBHandler()
{
	// Must correspond the "way" HomeNetwork was launched so we can make the parent dialog modal.
	// 0 - Launched From NisPlug
	// 1 - Launched From IntroWiz
	
	var lLaunchedFrom = 0;
	IntroHelp.LaunchHomeNetwork(lLaunchedFrom);		// Launched From NisPlug
}

function addrList_OnClick()
{
	// Enable the modify/delete buttons
	if(UserType == "UT_SUPERVISOR")
	{
		EnableButton(DeleteB,true);
	}
}

function addrList_OnDblClick()
{
	// Emulate a click on the modify button
	if(UserType == "UT_SUPERVISOR")
	{
		//ModifyB.click();
	}
}

function ClickTrusted()
{
	g_szCurTab = "NISTrusted";
	InitListFromXML(g_szCurTab);

	TabRestricted.style.border = "1 solid #000000";
//	TabLocal.style.border = "1 solid #000000";

	TabTrusted.style.border = "";
	TabTrusted.style.borderLeft = "2 solid #000000";
	TabTrusted.style.borderTop = "2 solid #000000";
	TabTrusted.style.borderRight = "2 solid #000000";
}

function ClickRestricted()
{
	g_szCurTab = "NISRestricted";
	InitListFromXML(g_szCurTab);

	TabTrusted.style.border = "1 solid #000000";
//	TabLocal.style.border = "1 solid #000000";

	TabRestricted.style.border = "";
	TabRestricted.style.borderLeft = "2 solid #000000";
	TabRestricted.style.borderTop = "2 solid #000000";
	TabRestricted.style.borderRight = "2 solid #000000";
}

function ClickLocal()
{
	g_szCurTab = "NISLocal";
	InitListFromXML(g_szCurTab);

	TabTrusted.style.border = "1 solid #000000";
	TabRestricted.style.border = "1 solid #000000";

	TabLocal.style.border = "";
	TabLocal.style.borderLeft = "1 solid #000000";
	TabLocal.style.borderTop = "1 solid #000000";
	TabLocal.style.borderRight = "1 solid #000000";
}

function OnLoad()
{
	// Set the current user name
	UserManager_OnUserChange();

	// Load the XML data from the engine...
	g_FirewallXML = new ActiveXObject("Microsoft.XMLDOM");
	g_FirewallXML.loadXML(Zones.FirewallData.xml);

	// Setup the list control
	addrList.SetTableClass("ListBoxClass");
	addrList.OnClick = addrList_OnClick;
	addrList.OnDblClick = addrList_OnDblClick;

	// Init from the trusted list since it is the first visible list
	TabTrusted.click();

	// Tell the user manager object that we want to know when
	// the home networking wizard runs
	UserManager.WatchForHNWizRun();
}

function UserManager_OnHomeNetWizardRun()
{
	g_FirewallXML.loadXML(Zones.FirewallData.xml);
	InitListFromXML(g_szCurTab);	
}

function UserManager_OnUserChange()
{
    CurUser.style.display = "none";
	var ProdType = UserManager.ProductType;
	if ((ProdType == "PT_FE") || (ProdType == "PT_NOAD"))
	{
        // DWong 01/16/01 Defect 347937 - display log in account
        // for family edition and no-ad products only

	    // If the PCWiz hasn't been run hide the user name
	    if(UserManager.PCWizRun)
        {
		    CurUser.style.display = "";

	        // Change the text for "User Logged in As" for Not Logged in User
	        // Since the user name of "Not Logged in" is an empty string.  We compare it against string lenght 0
	        var szCurrentUser = UserManager.CurrentUser;
	        if(szCurrentUser.length == 0)
            {
		        UserNameText.innerText = StrID("UserNotLoggedIn");
	            currentUser.innerHTML = "";
            }
            else
            {
		        UserNameText.innerText = StrID("UserLoggedIn");

	            // Set the current user name
	            currentUser.innerHTML = szCurrentUser;
            }
        }
	}

	UserType = UserManager.CurrentUserType;

	if(UserType != "UT_SUPERVISOR")
	{
		EnableButton(AddB,false);
		EnableButton(DeleteB,false);
		EnableButton(HomeNetB,false);
	}
	else
	{
		EnableButton(AddB,true);
		EnableButton(HomeNetB,true);
	}
}

function InitListFromXML(sztab)
{
	// Reset the list control
	addrList.DeleteAllRows();
	addrList.SetColumnCount(2);
	addrList.SetColumnWidth(0, "45%");
	addrList.SetColumnWidth(1, "55%");

	// Disable the modify/delete buttons
	EnableButton(DeleteB,false);

	// Get the node for this zone and walk the children
	var ZoneNode = GetPtrToZoneNode(sztab);
	if(ZoneNode)
	{
		var pZoneChildNodeList = ZoneNode.childNodes;
		var ChildCount = 0;

		for(ChildCount = 0; ChildCount < pZoneChildNodeList.length; ChildCount++)
		{
			var ZoneChildNode = pZoneChildNodeList.item(ChildCount);

			if(stricmp(ZoneChildNode.nodeName, "MaskedAddress") == 0)
			{
				var chunks = ZoneChildNode.nodeTypedValue.split(":");
				var text = StrID("IP") + ": " + chunks[0] + "<BR>" + StrID("Mask") + ": " + chunks[1];

				pRow = addrList.InsertRow(-1);
				addrList.SetCellTextPtr(pRow, 0, StrID("NetworkAddress"));
				addrList.SetCellTextPtr(pRow, 1, text);
			}
			else if(stricmp(ZoneChildNode.nodeName, "AddressRange") == 0)
			{
				var chunks = ZoneChildNode.nodeTypedValue.split(":");
				var text = StrID("From") + ": " + chunks[0] + "<BR>" + StrID("To") + ": " + chunks[1];

				pRow = addrList.InsertRow(-1);
				addrList.SetCellTextPtr(pRow, 0, StrID("AddressRange"));
				addrList.SetCellTextPtr(pRow, 1, text);
			}
			else if(stricmp(ZoneChildNode.nodeName, "NamedAddress") == 0)
			{
				var text = StrID("Name") + ": " + ZoneChildNode.nodeTypedValue;

				pRow = addrList.InsertRow(-1);
				addrList.SetCellTextPtr(pRow, 0, StrID("SingleAddress"));
				addrList.SetCellTextPtr(pRow, 1, text);
			}
			else if(stricmp(ZoneChildNode.nodeName, "Address") == 0)
			{
				var text = StrID("IP") + ": " + ZoneChildNode.nodeTypedValue;

				pRow = addrList.InsertRow(-1);
				addrList.SetCellTextPtr(pRow, 0, StrID("SingleAddress"));
				addrList.SetCellTextPtr(pRow, 1, text);
			}
		}
	}
}

function GetPtrToZoneNode(szZoneName)
{
	// Do a XSL Pattern search for the requested zone
	var szXSLSearch = "/FirewallData/Zones/Zone[ZoneName = \"" + szZoneName + "\"]";

	var zonenode = g_FirewallXML.selectSingleNode(szXSLSearch);

	if (!zonenode)
	{
		// there is no zone node of this type.  Create one now.

		var pnode = g_FirewallXML.createElement("ZoneName");
		pnode.text = szZoneName;

		var zonearea = g_FirewallXML.createElement("Zone");
		zonearea.appendChild(pnode);

		var zones = g_FirewallXML.selectSingleNode("/FirewallData/Zones");
		zones.appendChild(zonearea);

		// now try it again.
		zonenode = g_FirewallXML.selectSingleNode(szXSLSearch);

	}
	return zonenode;

}

function InsertDataIntoZone(szZoneName, xmlIPList)
{
	var ZoneNode = GetPtrToZoneNode(szZoneName);
	var IPCount;

	if (ZoneNode)
	{
        var addressNodeList = xmlIPList.selectNodes(".//(Address|NamedAddress|AddressRange|MaskedAddress)");
		for (IPCount = 0; IPCount < addressNodeList.length; IPCount++)
		{
			var IPEntry = addressNodeList.item(IPCount);
			var pNewElem = CreateElementForZone(szZoneName, IPEntry);

			if (pNewElem)
			{
				// Add the data to the zone
				ZoneNode.appendChild(pNewElem);
			}
		}

		// Save the list...
		Zones.FirewallData = g_FirewallXML;

		// Reload the displayed list
		InitListFromXML(szZoneName);
	}
}

function CreateElementForZone(szZoneName, xmlIPEntry)
{
	var ZoneNode = GetPtrToZoneNode(szZoneName);

	if(!ZoneNode || !xmlIPEntry)
		return null;

	var szElementName = null;
	var szElementValue = null;

	if(stricmp(xmlIPEntry.nodeName, "Address") == 0)
	{
		szElementName = "Address";
		szElementValue = xmlIPEntry.nodeTypedValue;
	}
	else if(stricmp(xmlIPEntry.nodeName, "NamedAddress") == 0)
	{
		szElementName = "NamedAddress";
		szElementValue = xmlIPEntry.nodeTypedValue;
	}
	else if(stricmp(xmlIPEntry.nodeName, "AddressRange") == 0)
	{
		szElementName = "AddressRange";
		var szText = "" + xmlIPEntry.nodeTypedValue;
		var chunks = szText.split(":");
		szElementValue = chunks[0] + ":" + chunks[1];
	}
	else if(stricmp(xmlIPEntry.nodeName, "MaskedAddress") == 0)
	{
		szElementName = "MaskedAddress";
		szElementValue = xmlIPEntry.nodeTypedValue;
	}

	//
	// Add the data to the zone
	//
	if(szElementName && szElementValue)
	{
		var pNewElem = g_FirewallXML.createElement(szElementName);
		pNewElem.text = szElementValue;
		return pNewElem;
	}

	return null;
}

function ModifyDataInZone(szZoneName, nItem, xmlIPList)
{
	var ZoneNode = GetPtrToZoneNode(szZoneName);
	var IPCount;

	if (ZoneNode)
	{
		// Get the old node
		nItem = nItem + 1;	// To move past <ZoneName>

        var addressNodeList = xmlIPList.selectNodes(".//(Address|NamedAddress|AddressRange|MaskedAddress)");
		for (IPCount = 0; IPCount < addressNodeList.length; IPCount++)
		{
			var IPEntry = addressNodeList.item(IPCount);
			var pNewElem = CreateElementForZone(szZoneName, IPEntry);
			var pOldElem = ZoneNode.childNodes.item(nItem);

			// Replace the node
			ZoneNode.replaceChild(pNewElem, pOldElem);
			nItem = nItem + 1;
		}

		// Save the list...
		Zones.FirewallData = g_FirewallXML;

		// Reload the displayed list
		InitListFromXML(szZoneName);
	}
}

function DeleteDataFromZone(szZoneName, nItem)
{
	var ZoneNode = GetPtrToZoneNode(szZoneName);

	// Remove the data from the zone
	if(ZoneNode)
	{
		nItem = nItem + 1;	// To move past <ZoneName>
		var ZoneChildNode = ZoneNode.childNodes.item(nItem);
		ZoneNode.removeChild(ZoneChildNode);

		// Save the list...
		Zones.FirewallData = g_FirewallXML;

		// Reload the displayed list
		InitListFromXML(szZoneName);
	}
}

function stricmp(szA, szB)
{
	if(szA.toUpperCase() < szB.toUpperCase())
		return -1;
	else if(szA.toUpperCase() > szB.toUpperCase())
		return 1;

	return 0;
}

function inet_addr( ipstring)
{
	var dwvalue = 0;
	var chunks;

  chunks = ipstring.split(".");

  if (chunks)
	{
		dwvalue = Number(chunks[0]) << 24;
		dwvalue += Number(chunks[1]) << 16;
		dwvalue += Number(chunks[2]) << 8;
		dwvalue += Number(chunks[3]);
	}

	return dwvalue;
}

