////////////////////////////////////////////////////////////////////////////////////////////
//
// PRODUCT: Norton Internet Security/Symantec Desktop Firewall
//
// NAME:    InternetAC.js (Javascript file for INTERNETAC.HTM)
//
// Copyright (c) 2001 by Symantec Corporation. All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////////////////

var g_bAutoCreateEnabled;
var g_nTimerID = 0;
var ApplicationListLoaded = false;

function Window_OnLoad()
{
    g_bAutoCreateEnabled = UserManager.AutoCreateEnabled;
	// Add some menu items
	ConfigMenu.AddItem(StrID("IACMenuSystem"), 0);
	ConfigMenu.AddItem(StrID("IACMenuTrojan"), 1);
	ConfigMenu.AddItem(StrID("IACMenuAppScan"), 2);
    if (g_bAutoCreateEnabled == true)
        ConfigMenu.AddItemWithState(1, StrID("IACMenuAutoCreate"), 3);
    else
        ConfigMenu.AddItemWithState(0, StrID("IACMenuAutoCreate"), 3);
	UserManager_OnUserChange();
    // DWong 01/12/01 On IE4 onload event for AppicationList did not get fired
    // for some reason, so let's just explicitly called it here
    AppList_OnLoad();
}

function ToggleAutoCreate()
{
    UserManager.AutoCreateEnabled = !g_bAutoCreateEnabled;
    // DWong 01/04/01 We have a confirmation dialog and user may change their mind
    // so we need to retrieve this enabled value again
	UpdateAutoCreate();
}

function UpdateAutoCreate()
{
    g_bAutoCreateEnabled = UserManager.AutoCreateEnabled;
    if (g_bAutoCreateEnabled == true)
        ConfigMenu.ChangeItemState(1, 3);
    else
        ConfigMenu.ChangeItemState(0, 3);
}

function OnAdd()
{
	AppicationList.Add();
}

function OnModify()
{
	AppicationList.Modify();
}

function OnRemove()
{
	AppicationList.Delete();
}

function AppList_OnLoad()
{
	AppicationList.UseRegistry = true;

    // DWong 01/10/01 The old code, put_UseRegistry (in AxAppList.cpp), creates the
    // rule list and put it in the list box. The load time of this page is then slow
    // if the user has many rules.
    // In order to speed up the response time of this page at load time, let's fool
    // the user and create a one-time timer function to load up the app list
    //
	SetApplicationListLoaded(false);
	g_nTimerID = window.setInterval("LoadAppList()", 100);
}

function LoadAppList()
{
	// stop the timer
	window.clearInterval(g_nTimerID);
    // DWong 01/10/01 Load up the app list from registry by calling Refresh
    //
	AppicationList.Refresh();
	SetApplicationListLoaded(true);
}

function AppList_OnSelect()
{
	UpdateModifyButtonState();
	UpdateRemoveButtonState();
	UpdateAddButtonState(); // necessary for ie4 wierdness
}

function UserManager_OnUserChange()
{
    CurUser.style.display = "none";
	var ProdType = UserManager.ProductType;
	if ((ProdType == "PT_FE") || (ProdType == "PT_NOAD"))
	{
        // DWong 01/16/01 Defect 347937 - display log in account
        // for family edition and no-ad products only

	    // If the PCWiz hasn't been run hide the user name
	    if(UserManager.PCWizRun)
        {
		    CurUser.style.display = "";

	        // Change the text for "User Logged in As" for Not Logged in User
	        // Since the user name of "Not Logged in" is an empty string.  We compare it against string lenght 0
	        var szCurrentUser = UserManager.CurrentUser;
	        if(szCurrentUser.length == 0)
            {
		        UserNameText.innerText = StrID("UserNotLoggedIn");
	            currentUser.innerHTML = "";
            }
            else
            {
		        UserNameText.innerText = StrID("UserLoggedIn");

	            // Set the current user name
	            currentUser.innerHTML = szCurrentUser;
            }
        }
	}
	UpdateAddButtonState();
	UpdateModifyButtonState();
	UpdateRemoveButtonState();
	UpdateConfigureButtonState();
	UpdateApplicationListState();
}

function ConfigMenu_OnClick(nItem)
{
	switch(nItem)
	{
		case 0:	// System settings
		{
			fwUI.EditSystemRules(0);
			break;
		}
		case 1:	// Trojan settings
		{
			fwUI.EditTrojanRules(0);
			break;
		}
		case 2:	// ALE Scan
		{
			fwUI.AleScan();
			break;
		}
        case 3: // Enable/disable AutoCreate
        {
            ToggleAutoCreate();
            break;
        }
	}
}

function UpdateAddButtonState ()
{
	EnableButton(AddBtn,ApplicationListLoaded && UserManager.CurrentUserType == "UT_SUPERVISOR");
}

function UpdateModifyButtonState ()
{
	EnableButton(Modify,ApplicationListLoaded && AppicationList.CurSelCount == 1 && UserManager.CurrentUserType == "UT_SUPERVISOR");
}

function UpdateRemoveButtonState ()
{
	EnableButton(Remove,ApplicationListLoaded && AppicationList.CurSelCount > 0 && UserManager.CurrentUserType == "UT_SUPERVISOR");
}

function UpdateApplicationListState()
{
    AppicationList.Enabled = ApplicationListLoaded && UserManager.CurrentUserType == "UT_SUPERVISOR";
}

function UpdateConfigureButtonState()
{
    ConfigureBtn.disabled = (UserManager.CurrentUserType != "UT_SUPERVISOR");
}

function UpdateApplicationListDisplayState()
{
    AppicationList.style.display= (ApplicationListLoaded ? "" : "none");
}

function UpdateLoadingTextDisplayState()
{
    Loading_Text.style.display=(ApplicationListLoaded ? "none" : "");
}

function SetApplicationListLoaded ( state )
{
	ApplicationListLoaded = state;
	UpdateAddButtonState();
	UpdateModifyButtonState();
	UpdateRemoveButtonState();
	UpdateApplicationListState();
	UpdateApplicationListDisplayState();
	UpdateLoadingTextDisplayState();
}
