////////////////////////////////////////////////////////////////////////////////////////////
//
// PRODUCT: Norton Internet Security/Symantec Desktop Firewall
//
// NAME:    Reporting.js (Javascript file for REPORTING.HTM)
//
// Copyright (c) 2001 by Symantec Corporation. All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////////////////

var UserType = "";

function OnLoad()
{
	// Set the current user name
	UserManager_OnUserChange();

	Slider1.Value = RLevel.Level;

    // DWong 1/03/01 - display the correct UI for the reporting level
    switch(Slider1.Value)
    {
        case 0:
			Show_Level(Reporting_High);
            break;
        case 1:
			Show_Level(Reporting_Medium);
            break;
        case 2:
			Show_Level(Reporting_Low);
            break;
    }
    
}

function GetStyleSheet(ruleName)
{
	var Rules = new Array();
	var styleCount = 0;
	for(var ssIndex = 0; ssIndex < document.styleSheets.length; ssIndex++)
	{
		styleSheet = document.styleSheets[ssIndex];
		for(var rIndex=0; rIndex < styleSheet.rules.length; rIndex++)
		{
			rule=styleSheet.rules[rIndex]
			if(rule.selectorText == ("." + ruleName) || rule.selectorText == ruleName)
			{
				Rules[styleCount] = rule
				styleCount++;
			}
		}
	}
	return Rules;
}

function SetStyle()
{

	var slideHdr;
	var slideDesc;
	var buttonHotKey;

	slideHdr = GetStyleSheet("sliderHdr")[0];
	slideDesc = GetStyleSheet("sliderDesc")[0];
	buttonHotKey = GetStyleSheet("buttonULine")[0];

	slideHdr.style.textDecorationUnderline = false;
	slideDesc.style.textDecorationUnderline = false;
	buttonHotKey.style.textDecorationUnderline = true;

	slideDesc.style.color = "#000000";
	buttonHotKey.style.color = "#000000";

	slideHdr.style.cursor = "default";
	slideDesc.style.cursor = "default";
	buttonHotKey.style.cursor = "default";




}

function Default_Level()
{
	Show_Level(Reporting_Low);
	RLevel.Level = 2;
	Slider1.Value = 2;
}

function Show_Level(pVisLevel)
{
	Reporting_High.style.display = "none";
	Reporting_Medium.style.display = "none";
	Reporting_Low.style.display = "none";

	pVisLevel.style.display = "";
}

function UserManager_OnUserChange()
{
    CurUser.style.display = "none";
	var ProdType = UserManager.ProductType;
	if ((ProdType == "PT_FE") || (ProdType == "PT_NOAD"))
	{
        // DWong 01/16/01 Defect 347937 - display log in account
        // for family edition and no-ad products only

	    // If the PCWiz hasn't been run hide the user name
	    if(UserManager.PCWizRun)
        {
		    CurUser.style.display = "";

	        // Change the text for "User Logged in As" for Not Logged in User
	        // Since the user name of "Not Logged in" is an empty string.  We compare it against string lenght 0
	        var szCurrentUser = UserManager.CurrentUser;
	        if(szCurrentUser.length == 0)
            {
		        UserNameText.innerText = StrID("UserNotLoggedIn");
	            currentUser.innerHTML = "";
            }
            else
            {
		        UserNameText.innerText = StrID("UserLoggedIn");

	            // Set the current user name
	            currentUser.innerHTML = szCurrentUser;
            }
        }
	}


	SetStyle();

	UserType = UserManager.CurrentUserType;
	if(UserType == "UT_RESTRICTED" || UserType == "UT_UNKNOWN")
	{
		DefaultLevel.disabled = true;
		Slider1.Enabled = 0;
	}
	else
	{
		DefaultLevel.disabled = false;	
		Slider1.Enabled = 1;
	}
}

function Slider_OnScroll()
{
    // DWong 01/15/01 Defect 351074 (scroll event never got fired on IE4)
    // Changed to use VC6 version of slider control, at the same time
    // move the event handler code for scroll into a single function
    switch(Slider1.Value)
    {
        case 0:
			Show_Level(Reporting_High);
            break;
        case 1:
			Show_Level(Reporting_Medium);
            break;
        case 2:
			Show_Level(Reporting_Low);
            break;
    }
	// Save the value
	RLevel.Level = Slider1.Value;

	SetStyle();
}
