////////////////////////////////////////////////////////////////////////////////////////////
//
// PRODUCT: Norton Internet Security/Symantec Desktop Firewall
//
// NAME:    SecCheck.js (Javascript file for SECCHECK.HTM)
//
// Copyright (c) 2001 by Symantec Corporation. All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////////////////

var UserType = "";

function OnLoad()
{
	// Set the current user name
	UserManager_OnUserChange();
}

function BuildURL()
{
	var szSysLang = navigator.systemLanguage;
	var szLangID = "";

	// Test 4 letter versions
	switch(szSysLang)
	{
		case "zh-tw":
		case "zh-hk":
			szLangID = "cn";
			break;
		case "zh-cn":
		case "zh-sg":
			szLangID = "scn";
			break;
		case "sv-fi":
			szLangID = "fi";
			break;
		case "nl-be":
			szLangID = "be";
			break;
	}

	if(!szLangID.length)
	{
		// Test 2 letter versions
		switch(szSysLang.substring(0, 2))
		{
			case "ja":
				szLangID = "jp";
				break;
			case "pt":
				szLangID = "br";
				break;
			case "de":
				szLangID = "de";
				break;
			case "fr":
				szLangID = "fr";
				break;
			case "es":
				szLangID = "mx";
				break;
			case "it":
				szLangID = "it";
				break;
			case "nl":
				szLangID = "nl";
				break;
			case "ko":
				szLangID = "kr";
				break;
			default:
				szLangID = "us";
				break;
		}
	}

	// Figure out what version of the product this is
	var szProdID = "";
	if(UserManager.ProductType == "PT_NPF")
		szProdID = "NPF40";
	else
		szProdID = "NIS40";

	var szRet = String("http://security.symantec.com/default.asp?productid=" + szProdID + "&langid=" + szLangID + "&venid=sym");
	return szRet;
}

function OpenSSC()
{
	UserManager.LaunchURL(BuildURL());
}

function UserManager_OnUserChange()
{
    CurUser.style.display = "none";
	var ProdType = UserManager.ProductType;
	if ((ProdType == "PT_FE") || (ProdType == "PT_NOAD"))
	{
        // DWong 01/16/01 Defect 347937 - display log in account
        // for family edition and no-ad products only

	    // If the PCWiz hasn't been run hide the user name
	    if(UserManager.PCWizRun)
        {
		    CurUser.style.display = "";

	        // Change the text for "User Logged in As" for Not Logged in User
	        // Since the user name of "Not Logged in" is an empty string.  We compare it against string lenght 0
	        var szCurrentUser = UserManager.CurrentUser;
	        if(szCurrentUser.length == 0)
            {
		        UserNameText.innerText = StrID("UserNotLoggedIn");
	            currentUser.innerHTML = "";
            }
            else
            {
		        UserNameText.innerText = StrID("UserLoggedIn");

	            // Set the current user name
	            currentUser.innerHTML = szCurrentUser;
            }
        }
	}
}

function SetSecIcon(bMouseOver)
{
	if(bMouseOver)
		SecIcon.src = "security_onstate.jpg";
	else	
		SecIcon.src = "security_offstate.jpg";
		
	return true;
}