////////////////////////////////////////////////////////////////////////////////////////////
//
// PRODUCT: Norton Internet Security/Symantec Desktop Firewall
//
// NAME:    Status.js (Javascript file for STATUS.HTM)
//
// Copyright (c) 2001 by Symantec Corporation. All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////////////////

var szEnabled = StrID("StatusEnabled");
var szDisabled = StrID("StatusDisabled");
var szEnable = StrID("StatusEnable");
var szDisable = StrID("StatusDisable");
var szEnable_noHK = StrID("StatusEnable_noHK");
var szDisable_noHK = StrID("StatusDisable_noHK");
var szUpdateServ = StrID("StatusUpdateServ");
var szUpdateServB = StrID("StatusUpdateServB");
var szUpdateExpired = StrID("StatusUpdateExpired");
var g_bCanMakeChanges = false;
// DWong 01/08/01 - Experimental stuff to increase the performance of this status page
// Moved the GetStyleSheet call within RefreshStats so that it won't be called
// at init time
var g_LinkRules = "";
var g_WhiteLink = "";
var g_TopItemBtnText = GetStyleSheet("topitembtntxt")[0];
var g_nRefreshCount = 15;	// Set to 15 so it will refresh the TC stats the first time around
var g_nTimerID = 0;
var g_IEVer = GetIEVersion();
var g_szUserType = "";
var g_OnUserChangeHit = false;
var g_IEversion = 0;
var g_szOpenItem = null;
var g_szOpenItemBtn = null;
var g_bEnabled = null;	// null, not false!
var g_Breathing = false;

function OnLoad()
{
	// Change the relative top pos of .topitembtntxt based on the browser version
	if(g_IEVer >= 5)
		g_TopItemBtnText.style.top = "0px";
	else
		g_TopItemBtnText.style.top = "-7px";
		
	g_Breathing = StatusInfo.Breathing;
	// Fake a user change
	UserManager_OnUserChange();

	ProdName.innerHTML = UserManager.ProductName;

	SecBtn_OnClick();

	// Add the Ad blocking and PC sections if they are part of this product
	var ProdType = UserManager.ProductType;
	if(ProdType == "PT_PE")
	{
		ButtonAd.style.display = "";
	}
	else if(ProdType == "PT_FE")
	{
		ButtonParen.style.display = "";
		ButtonAd.style.display = "";
	}
	else if(ProdType == "PT_NOAD")
	{
		ButtonParen.style.display = "";
	}

	EnDisBtn.disabled = true;	// UpdateTimer_Interval will set this correctly latter
	// Setup a timer to refresh the stats
	g_nTimerID = window.setInterval("UpdateTimer_Interval()", 1000);

	// Hide the text to enable/disable each component if the product is disabled
	if(!StatusInfo.ProductEnabled)
	{
		SecEnDis.style.display = "none";
		PrivEnDis.style.display = "none";
		AdEnDis.style.display = "none";
		ParenEnDis.style.display = "none";
	}

	// Set text for "Perseonal Firewall" or "Desktop Firewall"
	if (ProdType == "PT_SDF")
	{
		window.FirewallName.innerHTML = StrID("FirewallNameSDF");
		window.FirewallStatus.innerHTML = StrID("StatusFirewallSDF");
	}
	else
	{
		window.FirewallName.innerHTML = StrID("FirewallName");
		window.FirewallStatus.innerHTML = StrID("StatusFirewall");
	}



	// Do a refresh
    // DWong 01/08/01 - Experimental stuff to increase the performance of this status page
    // Let the timer to update the stats instead here in order to have a faster
    // display when the page is loaded the first time
    // The price to pay is users won't be able to see the real time stats
    // for a sec when the page is loaded
//	RefreshStats();

	// Prompt for the intro wiz if this is the first run
	StatusInfo.PromptForIntroWiz();
}

function OnUnload()
{
	// stop the timer
	window.clearInterval(g_nTimerID);
}


function UpdateService_OnClick()
{
	if(g_bCanMakeChanges)
	{
		StatusInfo.ShowSubsDialog();
	}
}

function EnDisBtn_OnClick()
{
	if(g_bCanMakeChanges)
	{
		StatusInfo.ProductEnabled = !StatusInfo.ProductEnabled;
	}
}

function DisplaySecAlert(src)
{
	event.cancelBubble = true;
	event.returnValue = false;

    StatusInfo.ShowSecurityAlert();
}

function SwapFeature(nFeature)
{
	if(g_bCanMakeChanges)
	{
		switch(nFeature)
		{
			case 0:
				if(StatusInfo.SecurityEnabled)
				{
					 SecCurStatus.innerHTML = szEnabled;
					 SecStatus.innerHTML = szDisable_noHK;
				}
				else
				{
					 SecCurStatus.innerHTML = szDisabled;
					 SecStatus.innerHTML = szEnable_noHK;
				}

				StatusInfo.SecurityEnabled = !StatusInfo.SecurityEnabled;
				break;

			case 1:
				if(StatusInfo.PrivacyEnabled)
				{
					 PrivCurStatus.innerHTML = szEnabled;
					 PrivStatus.innerHTML = szDisable_noHK;
				}
				else
				{
					 PrivCurStatus.innerHTML = szDisabled;
					 PrivStatus.innerHTML = szEnable_noHK;
				}

				StatusInfo.PrivacyEnabled = !StatusInfo.PrivacyEnabled;
				break;

			case 2:
				if(StatusInfo.ParentalEnabled)
				{
					 PCCurStatus.innerHTML = szEnabled;
					 PCStatus.innerHTML = szDisable_noHK;
				}
				else
				{
					 PCCurStatus.innerHTML = szDisabled;
					 PCStatus.innerHTML = szEnable_noHK;
				}

				StatusInfo.ParentalEnabled = !StatusInfo.ParentalEnabled;
				break;

			case 3:
				if(StatusInfo.AdBlockingEnabled)
				{
					 AdBlockingCurStatus.innerHTML = szEnabled;
					 AdBlockingStatus.innerHTML = szDisable_noHK;
				}
				else
				{
					 AdBlockingCurStatus.innerHTML = szDisabled;
					 AdBlockingStatus.innerHTML = szEnable_noHK;
				}

				StatusInfo.AdBlockingEnabled = !StatusInfo.AdBlockingEnabled;
				break;
		}
	}
}

function SetEnDisBtn(bEnabled)
{
	if(bEnabled == g_bEnabled)
		return;

	if(bEnabled)
	{
		EnDisBtn.innerHTML = szDisable;
		ProdLogo.src = "NISLogo.gif";
		EnDisText.innerHTML = StrID("StatusEnText");
		ProdName.innerHTML = UserManager.ProductName;
		g_bEnabled = true;
	}
	else
	{
		EnDisBtn.innerHTML = szEnable;
		ProdLogo.src = "NISLogo-dis.gif";
		EnDisText.innerHTML = StrID("StatusDisText");
		ProdName.innerHTML = UserManager.ProductName;
		g_bEnabled = false;
	}
}

function MoreStats_OnClick()
{
	if(g_bCanMakeChanges)
	{
		StatusInfo.MoreStatistics();
	}
}

function UserManager_OnUserChange()
{
    CurUser.style.display = "none";
	var ProdType = UserManager.ProductType;
	if ((ProdType == "PT_FE") || (ProdType == "PT_NOAD"))
	{
        // DWong 01/16/01 Defect 347937 - display log in account
        // for family edition and no-ad products only

	    // If the PCWiz hasn't been run hide the user name
	    if(UserManager.PCWizRun)
        {
		    CurUser.style.display = "";

	        // Change the text for "User Logged in As" for Not Logged in User
	        // Since the user name of "Not Logged in" is an empty string.  We compare it against string lenght 0
	        var szCurrentUser = UserManager.CurrentUser;
	        if(szCurrentUser.length == 0)
            {
		        UserNameText.innerText = StrID("UserNotLoggedIn");
	            currentUser.innerHTML = "";
            }
            else
            {
		        UserNameText.innerText = StrID("UserLoggedIn");

	            // Set the current user name
	            currentUser.innerHTML = szCurrentUser;
            }
        }
	}

	g_IEversion = GetIEVersion();
	g_OnUserChangeHit = true;


	g_szUserType = UserManager.CurrentUserType;

	// Can this user make changes?
	if(g_szUserType == "UT_RESTRICTED" || g_szUserType == "UT_UNKNOWN")
		g_bCanMakeChanges = false;
	else
		g_bCanMakeChanges = true;
}

function RefreshStats()
{
	StatusInfo.RefreshStats(-1);

	// Update what is displayed
	RefreshDisplayedStats();

    // DWong 01/08/01 - Experimental stuff to increase the performance of this status page
    // Moved the GetStyleSheet call within RefreshStats so that it won't be called
    // at init time 
    if (g_WhiteLink == "")
    {
        g_WhiteLink = GetStyleSheet("WhiteLink")[0];
    }
    if (g_LinkRules == "")
    {
        g_LinkRules = GetStyleSheet("Link")[0];
    }


	// this special casing of IE4 is because if this code is not executed then the 
	// disable/enable button loses its text.

	if (g_OnUserChangeHit == true || g_IEversion == 4)
	{

		if(g_bCanMakeChanges)
		{
			g_WhiteLink.style.textDecorationUnderline = true;
			g_LinkRules.style.textDecorationUnderline = true;
			g_LinkRules.style.color = "#0000FF";
			g_WhiteLink.style.cursor = "hand";
			g_LinkRules.style.cursor = "hand";
		}
		else
		{
			g_WhiteLink.style.textDecorationUnderline = false;
			g_LinkRules.style.textDecorationUnderline = false;
			g_LinkRules.style.color = "#000000";
			g_WhiteLink.style.cursor = "default";
			g_LinkRules.style.cursor = "default";
		}
		EnDisBtn.disabled = (g_Breathing && g_szUserType == "UT_SUPERVISOR" ? "" : "yes");
		g_OnUserChangeHit = false;
	}
}

function CountOf(str, char)
{
	str = str.toLowerCase();
	char = char.toLowerCase();
	var nCount = 0;
	var nLoc = str.indexOf(char, 0);
	while(nLoc != -1)
	{
		nCount++;
		nLoc = str.indexOf(char, nLoc + 1);
	}

	return nCount;
}

function EllipseDomain(str, nMaxLen, bInternalCall)
{
	var strCopy = str;
	var a = strCopy.split(/\./);
	var nSects = a.length;
	while(strCopy.length > nMaxLen && nSects > 0)
	{
		strCopy = a[0];
		for(var i = 1; i < nSects; i++)
			strCopy += "." + a[i];
			
		nSects--;
	}
	
	if(nSects == 0)
	{
		var domain;
		if (a.length > 1)
		{
			domain = a[a.length - 2];
		}
		else
		{
			domain = a[0];
		}

		strCopy = domain.substr(0, nMaxLen) + "...";

	}
	else if(nSects != a.length)
		strCopy += "...";

	if(!bInternalCall)
	{
		// Count the number of W's and M's in the string we are going to return.
		// for every 3, subtract 1 from nMaxLen, then call ourselves again
		var nCount = CountOf(str, "w") + CountOf(str, "m");
		nMaxLen -= nCount / 3;
		if(nMaxLen <= 0)
			nMaxLen = 5;	// Absolute minimum of 5 chars...

		strCopy = EllipseDomain(str, nMaxLen, true);
	}
	
	return strCopy;
}

function SetTextValueIfChanged(obj, value)
{
	if(obj.innerText != value || typeof(value) != typeof(obj.innerText))
		obj.innerText = value;
}

function RefreshDisplayedStats()
{
	switch(g_szOpenItem.id)
	{
		case "StatSec":
		{
			if(StatusInfo.AutoBlockEnabled)
			{
				var vDate = StatusInfo.SecLastAttack;
				var vDateStr = "";
				if(typeof(vDate) == "date")
					vDateStr = FormatDT(vDate, 2) + " " + FormatDT(vDate, 3);
				else
					vDateStr = vDate;
				SetTextValueIfChanged(SecLastAttack, vDateStr);
				SetTextValueIfChanged(SecAttacks, StatusInfo.SecAttacks);
				SetTextValueIfChanged(SecAttackers, StatusInfo.SecAttackers);
				SetTextValueIfChanged(SecMostFrequent, StatusInfo.SecMostFrequent);
			}
			else
			{
				var szInactive = StrID("StatusInactive");
				var szDesc = StrID("StatusInactiveSecDesc");

				SetTextValueIfChanged(SecLastAttack, szInactive);
				SecLastAttack.title = szDesc;
				SetTextValueIfChanged(SecAttacks, szInactive);
				SecAttacks.title = szDesc;
				SetTextValueIfChanged(SecAttackers, szInactive);
				SecAttackers.title = szDesc;
				SetTextValueIfChanged(SecMostFrequent, szInactive);
				SecMostFrequent.title = szDesc;
			}

			if(StatusInfo.SecurityEnabled)
			{
				 SetTextValueIfChanged(SecCurStatus, szEnabled);
				 SetTextValueIfChanged(SecStatus, szDisable_noHK);
			}
			else
			{
				 SetTextValueIfChanged(SecCurStatus, szDisabled);
				 SetTextValueIfChanged(SecStatus, szEnable_noHK);
			}

            //
            // Check for Security Alert and enable visual alert that can be clicked.
            //
            if(StatusInfo.SecurityAlert)
            {
                secAlertTextOff.style.display = "none";
                secAlertTextOn.style.display = "";
            }
            else
            {
                secAlertTextOn.style.display = "none";
                secAlertTextOff.style.display = "";
            }
            break;
		}
		case "StatPriv":
		{
			if(StatusInfo.CookieBlockingEnabled)
			{
				SetTextValueIfChanged(PrivCookiesBlocked, StatusInfo.PrivCookiesBlocked);
				SetTextValueIfChanged(PrivCookiesPermitted, StatusInfo.PrivCookiesPermitted);
				SetTextValueIfChanged(PrivCookieSitesBlocked, StatusInfo.PrivCookieSitesBlocked);
				SetTextValueIfChanged(PrivCookieSitesPermitted, StatusInfo.PrivCookieSitesPermitted);

				SetTextValueIfChanged(PrivMostFrequentBlock, EllipseDomain(StatusInfo.PrivMostFrequentBlock, 10));
				PrivMostFrequentBlock.title = StatusInfo.PrivMostFrequentBlock;

				SetTextValueIfChanged(PrivMostFrequentPermit, EllipseDomain(StatusInfo.PrivMostFrequentPermit, 10));
				PrivMostFrequentPermit.title = StatusInfo.PrivMostFrequentPermit;
			}
			else
			{
				var szInactive = StrID("StatusInactive");
				var szDesc = StrID("StatusInactiveDesc");
				SetTextValueIfChanged(PrivCookiesBlocked, szInactive);
				PrivCookiesBlocked.title = szDesc;
				SetTextValueIfChanged(PrivCookiesPermitted, szInactive);
				PrivCookiesPermitted.title = szDesc;
				SetTextValueIfChanged(PrivCookieSitesBlocked, szInactive);
				PrivCookieSitesBlocked.title = szDesc;
				SetTextValueIfChanged(PrivCookieSitesPermitted, szInactive);
				PrivCookieSitesPermitted.title = szDesc;
				SetTextValueIfChanged(PrivMostFrequentBlock, szInactive);
				PrivMostFrequentBlock.title = szDesc;
				SetTextValueIfChanged(PrivMostFrequentPermit, szInactive);				
				PrivMostFrequentPermit.title = szDesc;
			}

			SetTextValueIfChanged(PrivConfidBlock, StatusInfo.PrivConfidBlock);


			if(StatusInfo.PrivacyEnabled)
			{
				 SetTextValueIfChanged(PrivCurStatus, szEnabled);
				 SetTextValueIfChanged(PrivStatus, szDisable_noHK);
			}
			else
			{
				 SetTextValueIfChanged(PrivCurStatus, szDisabled);
				 SetTextValueIfChanged(PrivStatus, szEnable_noHK);
			}
			break;
		}
		case "StatAd":
		{
			SetTextValueIfChanged(AdsBlockedCount, StatusInfo.AdsBlockedCount);
			SetTextValueIfChanged(AdsBlockedTime, StatusInfo.AdsBlockedTime);
			SetTextValueIfChanged(AdsBlockedSize, StatusInfo.AdsBlockedSize);
			SetTextValueIfChanged(AdsMostFrequent, EllipseDomain(StatusInfo.AdsMostFrequent, 14));
			AdsMostFrequent.title = StatusInfo.AdsMostFrequent;
			if(StatusInfo.AdBlockingEnabled)
			{
				 SetTextValueIfChanged(AdBlockingCurStatus, szEnabled);
				 SetTextValueIfChanged(AdBlockingStatus, szDisable_noHK);
			}
			else
			{
				 SetTextValueIfChanged(AdBlockingCurStatus, szDisabled);
				 SetTextValueIfChanged(AdBlockingStatus, szEnable_noHK);
			}
			break;
		}
		case "StatParen":
		{
			SetTextValueIfChanged(PCSiteBlocks, StatusInfo.PCSiteBlocks);
			SetTextValueIfChanged(PCMostFrequent, StatusInfo.PCMostFrequent);
			SetTextValueIfChanged(PCAppBlocks, StatusInfo.PCAppBlocks);
			SetTextValueIfChanged(PCMostFreqApp, StatusInfo.PCMostFreqApp);
			if(StatusInfo.ParentalEnabled)
			{
				 SetTextValueIfChanged(PCCurStatus, szEnabled);
				 SetTextValueIfChanged(PCStatus, szDisable_noHK);
			}
			else
			{
				 SetTextValueIfChanged(PCCurStatus, szDisabled);
				 SetTextValueIfChanged(PCStatus, szEnable_noHK);
			}
			break;
		}
	}

	var bEnable = StatusInfo.ProductEnabled;
	// Hide the text to enable/disable each component if the product is disabled
	if(!bEnable)
	{
		SecEnDis.style.display = "none";
		PrivEnDis.style.display = "none";
		AdEnDis.style.display = "none";
		ParenEnDis.style.display = "none";
	}
	else
	{
		SecEnDis.style.display = "";
		PrivEnDis.style.display = "";
		AdEnDis.style.display = "";
		ParenEnDis.style.display = "";
	}

	// Set the enable/disable button
	SetEnDisBtn(bEnable);

	// Set the Subscription info...
	var lSubLength = StatusInfo.SubRemaining + 0;
	var dateEnd = StatusInfo.SubEndDate;
	var bWarning = StatusInfo.SubWarn;

	if(lSubLength == -1)
		lSubLength = "unknown";

	if(lSubLength < 10)
		bWarning = true;

	if(UserManager.ProductType == "PT_SDF")
		SetTextValueIfChanged(USdays, "");
	else
	{
		var newVal = "";
		if(lSubLength > 0)
			newVal = szUpdateServ + FormatDT(dateEnd, 2) + szUpdateServB;
		else
			newVal = szUpdateExpired;

		SetTextValueIfChanged(USdays, newVal);
	}

	if(bWarning)
		UpdateService.style.color = "#FF0000";
	else
		UpdateService.style.color = "#000000";
}

function GetStyleSheet(ruleName)
{
	var Rules = new Array();
	var styleCount = 0;
	for(var ssIndex = 0; ssIndex < document.styleSheets.length; ssIndex++)
	{
		styleSheet = document.styleSheets[ssIndex];
		for(var rIndex=0; rIndex < styleSheet.rules.length; rIndex++)
		{
			rule=styleSheet.rules[rIndex]
			if(rule.selectorText == ("." + ruleName) || rule.selectorText == ruleName)
			{
				Rules[styleCount] = rule
				styleCount++;
			}
		}
	}
	return Rules;
}

function UpdateTimer_Interval()
{
	// Update the time consuming stats every 15 seconds instead of every second
	if(g_nRefreshCount >= 15)
	{
		StatusInfo.RefreshTCStats(g_szOpenItem.id);
		g_nRefreshCount = -1;
	}

	RefreshStats();
	g_nRefreshCount++;
}

function ShowItem(item, subarea)
{
	// selected item should have 18px Padding, all others should have 11px
	// Also need to swap background bitmaps...
	if(g_szOpenItemBtn != null)
		SetBkgnd(g_szOpenItemBtn, "url('widebtnBackground.gif')", "11px");

	SetBkgnd(item, "url('widebtnBackground-dn.gif')", "18px");

	// Show the correct sub item
	if(g_szOpenItem != null)
		g_szOpenItem.style.display = "none";

	subarea.style.display = "";
	
	// Save which area is open so we only refresh the stats for it...
	g_szOpenItemBtn = item;
	g_szOpenItem = subarea;
	
	// Refresh the stats for the now displayed area
	StatusInfo.RefreshTCStats(g_szOpenItem.id);
	RefreshDisplayedStats();
	
	return true;
}
